import { select } from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const g = svg
  .append('g')
  .attr(
    'transform',
    `translate(${width / 2}, ${height / 2})`,
  );

const face = g
  .append('circle')
  .attr('r', height / 2)
  .attr('fill', 'yellow')
  .attr('stroke', 'yellow');

const eyeSpacing = 88;
const eyeYOffset = -50;
const eyeRadiusX = 35;
const eyeRadiusY = 35;
const eyebrowWidth = 90;
const eyebrowHeight = 15; // Adjusted for a more natural curve
const eyebrowYOffset = -75; // Adjusted for positioning above the eyes

const eyesG = g
  .append('g')
  .attr('transform', `translate(0, ${eyeYOffset})`);

eyesG
  .append('ellipse')
  .attr('rx', eyeRadiusX)
  .attr('ry', eyeRadiusY)
  .attr('cx', -eyeSpacing)
  .attr('cy', 0);

eyesG
  .append('ellipse')
  .attr('rx', eyeRadiusX)
  .attr('ry', eyeRadiusY)
  .attr('cx', eyeSpacing)
  .attr('cy', 0);

// Using arc to create curved eyebrows
const eyebrowsG = eyesG
  .append('g')
  .attr('transform', `translate(0, ${eyebrowYOffset})`);

function eyebrowArc(eyePosition) {
  return arc()({
    innerRadius: 20,
    outerRadius: 30,
    startAngle: -0.5 * Math.PI,
    endAngle: 0.5 * Math.PI,
  });
}

eyebrowsG
  .append('path')
  .attr('d', eyebrowArc(-eyeSpacing))
  .attr('transform', `translate(${-eyeSpacing}, 0)`);

eyebrowsG
  .append('path')
  .attr('d', eyebrowArc(eyeSpacing))
  .attr('transform', `translate(${eyeSpacing}, 0)`);

// Adjusted mouth to make the smile extended
const mouth = g
  .append('path')
  .attr(
    'd',
    arc()({
      innerRadius: 140,
      outerRadius: 160,
      startAngle: Math.PI / 1.5,
      endAngle: (Math.PI * 3) / 2.3,
    }),
  )
  .attr('fill', 'black');
